<?php

include_once('global.php');

class IndexPage extends Page
{
  var $Dependencies = array('News');
  var $FullTitle = '<strong>ZděchovNET</strong> - komunitní počítačová síť';
  var $ShortTitle = 'Rozcestník';
  var $Links = array(
    'main' => array('Důležité odkazy',
      array('Finance', '/finance/', 'money.gif'),
      array('Statistika', 'http://stat.zdechov.net/centrala/', 'chart.gif'),
      array('Prohledat sdílení', '/share/', 'prohledavac_sdileni.gif', array('Share', 'Display')),
      array('Seznam uživatelů', '/userlist.php', 'comp.gif'),
      array('Seznam počítačů', '/hostlist.php', 'comp.gif'),
      array('Historie chatu', '/chat/history.php', 'sunrisechat.gif', array('Chat', 'Display')),
      array('Webový chat', 'http://embed.mibbit.com/?server=game.zdechov.net%3A6667&amp;channel=%23zdechov&amp;forcePrompt=true&amp;charset=utf-8', 'sunrisechat.gif'),
      array('Diskusní fórum', '/forum/', 'discus.gif'),
      array('WebMail', '/webmail/', 'openwebmail.gif'),
      array('Jídelníček', '/jidelna/', 'apple.gif'),
      array('Televize', 'http://tv.zdechov.net/', 'clear.gif'),
      array('Herní server', 'http://game-server.zdechov.net/', 'cube.gif'),
      array('Rozpis mší', 'http://farnost.zdechov.net/', 'cfix.gif'),
      array('Telefonní seznam', '/telseznam.php', 'tel.gif'),
      array('Mapa Zděchova', 'http://www.mapy.cz/#x=141560832@y=133134848@z=13@mm=FP@sa=s@st=s@ssq=zd%C4%9Bchov@sss=1@ssp=120738725_123701121_150360997_149800833', 'clear.gif'),
      array('Otvírací doby', '/otevreno.php', 'otv_doby.gif'),
      array('Topologie sítě', '/is/topologie.php', 'topologie.gif'),
      array('Dostupnost sítě', '/network/dostupnost.php', 'satellite.gif'),
      array('Technické informace', '/network.php', 'tech.gif'),
      array('Fotbal Sokol Zděchov', 'http://fotbal.zdechov.net/', 'socer.gif'),
      array('Webkamera', '/webcam/', 'clear.gif'),
      array('Stránky naší sítě', 'http://www.zdechov.net/', 'clear.gif'),
    ),
    'other' => array('Další odkazy',
      array('Kanály kabelovky', '/tkr.php', 'tv.gif'),
      array('Historie sítě', '/history.php', 'clear.gif'),
      array('Měřič spotřeby', '/merak.php', 'electric.gif'),
      array('Plány do budoucna', '/ukoly.php', 'clear.gif'),
    ),
    'search' => array('Vyhledávání',
      array('Google', 'http://www.google.cz/', 'www_google_com.gif'),
      array('Morfeo', 'http://morfeo.centrum.cz/', 'morfeo.png'),
      array('Centrum', 'http://www.centrum.cz/', 'www_centrum_cz.gif'),
      array('Seznam', 'http://www.seznam.cz/', 'www_seznam_cz.gif'),
      array('Atlas', 'http://www.atlas.cz/', 'www_atlas_cz.gif'),
      array('Tiscali', 'http://www.tiscali.cz/', 'www_tiscali_cz.gif'),
    ),
    'usefull' => array('Užitečné',
      array('Mapa ČR', 'http://www.mapy.cz/', 'clear.gif'),
      array('Online TV', 'http://www.tvinfo.cz/live/televize/cz/', 'www_tvinfo_cz.gif'),
      array('Jízdní řády', 'http://jizdnirady.idnes.cz/', 'www_idos_cz.gif'),
      array('TV programy', 'http://tv.atlas.cz/', 'www_atlas_cz.gif'),
      array('ICQ', 'javascript:openClient(\'flash\')', 'www_icq_com.gif'),
      array('Slovníky', 'http://slovniky.centrum.cz/', 'www_centrum_cz.gif'),
      array('Počasí', 'http://www.meteopress.cz/', 'pocasi.gif'),
      array('T-Mobile SMS', 'http://www.tzones.cz/', 'www_tzones_cz.gif'),
      array('Knihovna&nbsp;Vsetín', 'http://www.mvk.cz/', 'www_mvk_cz.png'),    
    ),
    'fun' => array('Zábava',
	  array('Youtube', 'http://www.youtube.com/', 'clear.gif'),
      array('Last.fm', 'http://www.last.fm/', 'clear.gif'),    
    ),
    /*'computers' => array('Prodej počítačů',
      array('SOFTCOM', 'http://www.softcom.cz/', 'www_computershop_cz.png'),
      array('Alfacomp', 'http://www.alfacomp.cz/php/zbozi.php?akc=2', 'www_alfacomp_cz.gif'),
      array('Petracomp', 'http://www.petracomp.cz/', 'www_petracomp_cz.png'),
      array('TS Bohemia', 'http://interlink.tsbohemia.cz/', 'www_tsbohemia_cz.png'),
    ),
      */
  );
  
  function ShowLinks($LinkGroup)
  {
    $Result = '';
    //foreach($this->Links as $LinkGroup)
    //{
      $Title = array_shift($LinkGroup);
      $Result .= '<div class="PanelTitle">'.$Title.'</div>';
      foreach($LinkGroup as $Link)
      {
        if(substr($Link[1], 0, 4) != 'http') $Link[1] = $this->System->Config['Web']['RootFolder'].$Link[1];
        if(!isset($Link[3]) or (isset($Link[3]) and $this->System->Modules['User']->CheckPermission($Link[3][0], $Link[3][1])))
          $Result .= '<img alt="'.$Link[0].'" src="images/favicons/'.$Link[2].'" width="16" height="16" /> <a href="'.$Link[1].'">'.$Link[0].'</a><br />';
      }
    //}
    return($Result);
  }

  function InfoBar()
  {
    $this->Database->select_db('is');

    $Output2 = '';

    $DbResult = $this->Database->select('hosts', 'COUNT(*)', 'show_online=1');
    $DbRow = $DbResult->fetch_array();
    $TotalComputers = $DbRow[0];

    $DbResult = $this->Database->select('hosts', 'COUNT(*)', 'show_online=1 AND online=1');
    $DbRow = $DbResult->fetch_array();
    $OnlineComputers = $DbRow[0];

    $Output = '<img alt="" src="images/favicons/comp.gif" width="16" height="16" /> '.$OnlineComputers.' / '.$TotalComputers.' &nbsp;  &nbsp; ';

    $DbResult = $this->Database->select('users', 'COUNT(*)', 'role=2');
    $DbRow = $DbResult->fetch_array();
    $TotalUser = $DbRow[0];

    $DbResult = $this->Database->select('hosts', 'COUNT(DISTINCT(user))', 'show_online=1 AND online=1');
    $DbRow = $DbResult->fetch_array();
    $OnlineUser = $DbRow[0];

    $Output .= '<img alt="" src="images/favicons/house.gif" width="16" height="16" /> '.$OnlineUser.' / '.$TotalUser.' &nbsp;  &nbsp; ';

    $NetworkUsage = 0;
    $Output .= '<img alt="" src="images/favicons/usage.gif" width="16" height="16" /> '.$NetworkUsage.' % &nbsp;  &nbsp; ';

    //$Output .= 'Server běží: '.$this->GetServerUptime().' &nbsp;  &nbsp; ';

    if($this->System->Modules['User']->CheckPermission('Finance', 'DisplaySubjectState'))
    {
      $DbResult = $this->Database->select('users', 'cash', 'User='.$this->System->Modules['User']->User['Id']);
      if($DbResult->num_rows > 0)
      {
        $DbRow = $DbResult->fetch_array();
        $Finance = $DbRow[0];
        $Output2 .= ' &nbsp;  &nbsp; <img alt="" src="images/favicons/money.gif" width="16" height="16" /> '.$Finance.' Kč';
      }
    }

    $Output = '<div class="Navigation"><span class="MenuItem">'.$Output.'</span><div class="MenuItem2">&nbsp;'.$Output2.'</div></div>';
    return($Output);
  }

  function UserPanel()
  {
    $Output = '<div class="PanelTitle">Nabídka uživatele:</div>'.
    '<a href="'.$this->System->Config['Web']['RootFolder'].'/?Action=UserOptions">Nastavení účtu</a><br />';
    if($this->System->Modules['User']->CheckPermission('Finance', 'DisplaySubjectState')) 
	  $Output .= '<a href="'.$this->System->Config['Web']['RootFolder'].'/finance/user_state.php">Stav financí</a><br />';
    if($this->System->Modules['User']->CheckPermission('Network', 'RegistredHostList')) 
	  $Output .= '<a href="'.$this->System->Config['Web']['RootFolder'].'/network/user_hosts.php">Registrované počítače</a><br />';
    //if($this->System->Modules['User']->CheckPermission('EatingPlace', 'Edit')) 
	  $Output .= '<a href="'.$this->System->Config['Web']['RootFolder'].'/aktuality/?action=add">Vložení aktuality</a><br />';
    if($this->System->Modules['User']->CheckPermission('EatingPlace', 'Edit')) $Output .= '<a href="'.$this->System->Config['Web']['RootFolder'].'/jidelna/menuedit.php">Editace jídelníčků</a><br />';
    if($this->System->Modules['User']->CheckPermission('Finance', 'Manage')) $Output .= '<a href="'.$this->System->Config['Web']['RootFolder'].'/finance/manage.php">Správa financí</a><br />';
    if($this->System->Modules['User']->CheckPermission('Network', 'Administration')) $Output .= '<a href="'.$this->System->Config['Web']['RootFolder'].'/is/administration_page.php">Správa sítě</a><br />';
    return($Output);
  }

  function WebcamPanel()
  {
    $Output = '<div class="PanelTitle">Webkamery</div>';
    $Output .= $this->System->Modules['Webcam']->ShowImage();
    return($Output);
  }

  // Zobrazení seznamu online počítačů
  function OnlineHostList()
  {
    global $Database;

    $Output = '<div class="PanelTitle">Online počítače</div><span style="font-size: smaller;">';
    $DbResult = $Database->select('hosts', '*', 'online=1 AND show_online=1 ORDER BY name');
    while($Row = $DbResult->fetch_array())
    {
      $Output .= $Row['name'].'<br />';
    }
    $Output .= '</span>';
    return($Output);
  }

  // Zobrazení seznamu neplaticich uzivatelu
  function ShowBadPayerList()
  {
    $Output .= '<div class="PanelTitle">Dlužníci:</div><span style="font-size: smaller;">';
    $DbResult = $Database->select('users', 'CONCAT(second_name, " ", first_name) as fullname', 'cash<0 AND role=2 ORDER BY cash');
    while($Row = $DbResult->fetch_array())
    {
      $Output .= $Row['fullname'].'<br />';
    }
    $Output .= '</span>';
    return($Output);
  }

  // Zobrazení času běhu počítače
  function GetServerUptime()
  {
    $Data = explode(' ',exec('uptime'));
    $Data = array_slice($Data,3,-8);
    $Uptime = '';
    foreach($Data as $Item)
    {
      if(strpos($Item,':')) $Uptime .= substr($Item,0,-1).' hodin';
      else $Uptime .= $Item.' ';
    }
    $Uptime = str_replace('2 days,','2 dny a',$Uptime);
    $Uptime = str_replace('3 days,','3 dny a',$Uptime);
    $Uptime = str_replace('4 days,','4 dny a',$Uptime);
    $Uptime = str_replace('days,','dní a',$Uptime);
    $Uptime = str_replace('day,','den a',$Uptime);
    $Uptime = str_replace('min,','minut',$Uptime);
    return($Uptime);
  }

  function Show()
  {
    global $Database, $Config, $User;

    //$Database->select_db('share');
    //$Output = $this->InfoBar();
    // Process cookies
	$Output = '';
    if(array_key_exists('Action', $_GET))
    {
      if($_GET['Action'] == 'CustomizeNewsSave')
      {
        $Output .= $this->System->Modules['News']->CustomizeSave();
      } else
      if($_GET['Action'] == 'LoginForm')
      {
        $Output .= '<form action="?Action=Login" method="post"><center><fieldset style="width: 500px;"><legend>Přihlašovací údaje</legend>
       <table class="hidden">
            <tr align="left"><td colspan="2">Jméno:</td></tr>
	    <tr align="left"><td colspan="2"><input type="text" name="Username" size="40" maxlength="16" /></td></tr>
	    <tr align="left"><td colspan="2">Heslo:</td></tr>
	    <tr align="left"><td colspan="2"><input type="password" name="Password" size="40" maxlength="16" /></td></tr>
	    <tr><td colspan="2">&nbsp;</td></tr>
	    <tr align="left">
  		<td><input type="checkbox" name="remember" value="1" checked="checked" /> Trvalé přihlášení</td>
		<td align="right"><input type="submit" value="Přihlásit" /></td>
	</tr>
	<tr align="left">
		<td><a href="?Action=UserRegister">Registrovat se</a></td>
		<td><a href="?Action=PasswordRecovery">Obnova zapomenutého hesla</a></td>
	</tr>
       </table>
       </fieldset></center>
       </form>';
//        $Output .= $this->SystemMessage('Test', $Output);
      } else
      if($_GET['Action'] == 'Login')
      {
        $Output .= $this->SystemMessage('Přihlášení', $this->System->Modules['User']->Login($_POST['Username'], $_POST['Password']));
      } else 
      if($_GET['Action'] == 'Logout')
      {
        $Output .= $this->SystemMessage('Odhlášení', $this->System->Modules['User']->Logout());
      } else
      if($_GET['Action'] == 'UserOptions')
      { 
        $UserOptions = new Form('UserOptions');
        $UserOptions->LoadValuesFromDatabase($this->System->Modules['User']->User['Id']);
        $UserOptions->OnSubmit = '?Action=UserOptionsSave';
        $Output .= $UserOptions->ShowEditForm();
      } else
      if($_GET['Action'] == 'UserOptionsSave')
      {
        $UserOptions = new Form('UserOptions', array());
        $UserOptions->LoadValuesFromForm();
        $UserOptions->SaveValuesToDatabase($this->System->Modules['User']->User['Id']);
        $Output .= $this->SystemMessage('Nastavení', 'Nastavení uloženo.');
        $this->System->Modules['Log']->NewRecord('User', 'Nastavení uživatele změněno', $UserOptions->Values['Name']);
      }
      if($_GET['Action'] == 'UserRegister')
      {
        $UserRegister = new Form('UserRegister');
        $UserRegister->OnSubmit = '?Action=UserRegisterSave';
        $Output .= $UserRegister->ShowEditForm();
      } else
      if($_GET['Action'] == 'UserRegisterConfirm')
      {
          $Output .= $this->SystemMessage('Potvrzení registrace', $this->System->Modules['User']->RegisterConfirm($_GET['User'], $_GET['H']));
      } else
      if($_GET['Action'] == 'PasswordRecovery')
      {
        $Form = new Form('PasswordRecovery');
        $Form->OnSubmit = '?Action=PasswordRecovery2';
        $Output .= $Form->ShowEditForm();
      } else
      if($_GET['Action'] == 'PasswordRecovery2')
      {
        $Form = new Form('PasswordRecovery');
        $Form->LoadValuesFromForm();

        $Output .= $this->SystemMessage('Obnova hesla', $this->System->Modules['User']->PasswordRecoveryRequest($Form->Values['Name'], $Form->Values['Email']));
      } else
      if($_GET['Action'] == 'PasswordRecoveryConfirm')
      {
        $Output .= $this->SystemMessage('Obnova hesla', $this->System->Modules['User']->PasswordRecoveryConfirm($_GET['User'], $_GET['H'], $_GET['P']));
      } else
      if($_GET['Action'] == 'UserRegisterSave')
      {
        $UserRegister = new Form('UserRegister', array());
        $UserRegister->LoadValuesFromForm();
        $Output .= $this->SystemMessage('Nastavení', $this->System->Modules['User']->Register($UserRegister->Values['Name'], $UserRegister->Values['Password'], $UserRegister->Values['Password2'], $UserRegister->Values['Email'], $UserRegister->Values['FirstName'], $UserRegister->Values['SecondName']));
      }
    }

    $Database->select_db('is');

    $Output .= '<table id="MainTable"><tr><td valign="top">';
    $Output .= '<div class="Panel">'.$this->ShowLinks($this->Links['main']).'</div>';
    $Output .= '<div class="Panel">'.$this->ShowLinks($this->Links['other']).'</div>';
    $Output .= '</td><td valign="top">';
    $Output .= '<div class="Panel">'.$this->ShowLinks($this->Links['search']).'</div>';
    $Output .= '<div class="Panel">'.$this->ShowLinks($this->Links['usefull']).'</div>';
    $Output .= '<div class="Panel">'.$this->ShowLinks($this->Links['fun']).'</div>';
    $Output .= '</td><td id="NewsColumn" valign="top">';
    $Output .= '<div class="Panel">'.$this->System->Modules['News']->Show().'</div>';
    $Output .= '</td><td valign="top">';
    if($this->System->Modules['User']->User['Id'] != $this->System->Modules['User']->AnonymousUserId) 
	  $Output .= '<div class="Panel">'.$this->UserPanel().'</div>';
    $Output .= '<div class="Panel">'.$this->WebcamPanel().'</div>';
    $Output .= '<div class="Panel">'.$this->OnlineHostList().'</div>';
    $Output .= '<br />';
    $Output .= '</td></tr></table>';
    //if(IsInternetAddr()) echo('Internet'); else echo('LAN');
    return($Output);
  }
}

$System->AddModule(new IndexPage());
$System->Modules['IndexPage']->GetOutput();

?>
